<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks® NonCommercial, 7.3 of vendredi 3 décembre 2004 on jeudi 7 décembre 2006 at 7:07:09</time-stamp>


<class>
<name>VisualLauncher</name>
<environment>Tools</environment>
<super>UI.ApplicationModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>menuBar toolBar textCollector toolDock </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>Tools-Misc</category>
<attributes>
<package>Tools-Misc</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>class initialization</category>

<body package="Tools-Misc" selector="classMethodsChanged">classMethodsChanged
	^self instanceMethodsChanged</body>

<body package="Tools-Misc" selector="instanceMethodsChanged">instanceMethodsChanged
	"A Menu has changed.  Update all open Launcher menuBars."

	ScheduledWindow scheduledControllers do: 
		[:each | 
		(each model isKindOf: self) ifTrue: 
			[(each model)
				rebuildMenu;
				updateToolBar]]</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>interface specs</category>

<body package="Tools-Misc" selector="interfaceSpecFor:">interfaceSpecFor: aSymbol

	| spec |
	spec := super interfaceSpecFor: aSymbol.
	aSymbol == #windowSpec
		ifTrue: [spec window toolBar: #launcherToolBar].
	^spec</body>

<body package="Tools-Misc" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#properties: #(#{UI.PropertyListDictionary} #labelFromApplication true ) 
			#label: 'VisualWorks team' 
			#min: #(#{Core.Point} 300 125 ) 
			#max: #(#{Core.Point} 0 0 ) 
			#bounds: #(#{Graphics.Rectangle} 515 414 1015 614 ) 
			#flags: 4 
			#menu: #newMenuBar ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 0 0 0 1 -25 1 ) 
					#name: #textViewID 
					#flags: 9 
					#component: #textView ) 
				#(#{UI.SubCanvasSpec} 
					#layout: #(#{Graphics.LayoutFrame} 0 0 -25 1 0 1 0 1 ) 
					#name: #statusBar 
					#flags: 0 ) ) ) )</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>generated resources</category>

<body package="Tools-Misc" selector="allClassesIcon">allClassesIcon
	
	^ToolbarIconLibrary visualFor: #classBrowser</body>

<body package="Store-UI" selector="allPackagesIcon">allPackagesIcon

	^ToolbarIconLibrary visualFor: #storeBrowser</body>

<body package="Tools-Misc" selector="allParcelsIcon">allParcelsIcon

	^ToolbarIconLibrary visualFor: #parcelBrowser</body>

<body package="Tools-Parcel Manager" selector="cardfile">cardfile

	^ToolbarIconLibrary visualFor: #cardfile</body>

<body package="Tools-Misc" selector="dbToolIcon">dbToolIcon

	^ToolbarIconLibrary visualFor: #database</body>

<body package="Tools-Misc" selector="extFinderIcon">extFinderIcon

	^ToolbarIconLibrary visualFor: #cpokBrowser</body>

<body package="Tools-Misc" selector="fileBrowser">fileBrowser

	^ToolbarIconLibrary visualFor: #fileBrowser</body>

<body package="Tools-Misc" selector="fileListIcon">fileListIcon

	^ToolbarIconLibrary visualFor: #fileFinder</body>

<body package="UIPainter" selector="finderIcon">finderIcon

	^ToolbarIconLibrary visualFor: #resourceFinder</body>

<body package="Tools-Misc" selector="fullMenuBar">fullMenuBar

	| menu |
	menu := self menuBar.
	(menu atNameKey: #advanced)
		submenu: [self regenerateAdvancedMenu];
		enabled: [self hasAdvancedTools].
	(menu atNameKey: #dllcc)
		enabled: [#{ExternalInterfaceFinder} isDefined].
	(menu atNameKey: #window)
		submenu: [self buildWindowMenu].
	(menu atNameKey: #adHoc) 
		enabled: [#{AdHocQueryTool} isDefined].
	(menu atNameKey: #dataModeler) 
		enabled: [#{LensEditor} isDefined].
	(menu atNameKey: #canvasComposer) 
		enabled: [#{LensApplicationSpec} isDefined].
	(menu atNameKey: #dataForm) 
		enabled: [#{UIFinderVW2} isDefined
				and: [#{LensApplicationSpecEditor} isDefined]].
	(menu atNameKey: #dataBaseAp) 
		enabled: [(#{UIFinderVW2} isDefined)
				and: [#{LensMainApplication} isDefined]].

	^menu</body>

<body package="Tools-Misc" selector="helpIcon">helpIcon

	^ToolbarIconLibrary visualFor: #thought</body>

<body package="Tools-Misc" selector="newCanvasIcon">newCanvasIcon

	^ToolbarIconLibrary visualFor: #canvas</body>

<body package="Tools-Settings-VW" selector="properties">properties

	^ToolbarIconLibrary visualFor: #properties</body>

<body package="Tools-Misc" selector="systemIcon">systemIcon

	^ToolbarIconLibrary visualFor: #systemBrowser</body>

<body package="Tools-Misc" selector="workspaceIcon">workspaceIcon

	^ToolbarIconLibrary visualFor: #workspace</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>resources</category>

<body package="UIPainter" selector="BWAppFinder24">BWAppFinder24
	"UIMaskEditor new openOnClass: self andSelector: #BWAppFinder24"

	&lt;resource: #image&gt;
	^CachedImage on: (Image extent: 24@24 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[0 0 0 0 127 255 254 0 64 0 2 0 127 255 250 0 127 255 250 0 95 255 250 0 84 0 10 0 74 0 10 0 73 255 106 0 72 137 106 0 72 127 10 0 68 41 106 0 68 31 106 0 68 9 10 0 68 5 106 0 68 3 106 0 68 1 10 0 71 240 138 0 65 254 74 0 64 15 42 0 64 1 242 0 64 0 122 0 127 255 254 0 0 0 0 0 ])</body>

<body package="DLLCC" selector="BWExtFinder24">BWExtFinder24
	"UIMaskEditor new openOnClass: self andSelector: #BWExtFinder24"

	&lt;resource: #image&gt;
	^CachedImage on: (Image extent: 24@24 depth: 1 bitsPerPixel: 1 palette: CoveragePalette monoMaskPalette usingBits: #[255 255 255 0 128 0 1 0 191 255 253 0 148 42 21 0 159 255 253 0 152 0 5 0 144 15 5 0 146 31 133 0 146 25 133 0 146 24 5 0 146 24 5 0 146 24 5 0 146 24 5 0 158 25 133 0 154 31 133 0 154 15 5 0 254 0 5 0 211 255 197 0 240 0 29 0 144 0 1 0 159 255 253 0 128 0 1 0 255 255 255 0 0 0 0 0 ])</body>

<body package="DLLCC" selector="BWExtFinder32">BWExtFinder32
	"UIMaskEditor new openOnClass: self andSelector: #BWExtFinder32"

	&lt;resource: #image&gt;
	^CachedImage on: (Image extent: 32@32 depth: 1 bitsPerPixel: 1 palette: MonoMappedPalette blackWhite usingBits: #[0 0 0 0 63 255 255 254 95 255 255 254 111 255 255 254 112 0 0 6 117 245 87 214 112 0 0 6 115 255 255 246 119 255 255 246 119 126 3 246 119 124 1 246 119 124 1 246 119 124 113 246 119 124 127 246 119 124 127 246 119 124 127 246 119 124 127 246 119 124 113 246 116 124 1 246 117 124 1 246 117 126 3 246 68 127 255 246 87 127 255 246 87 0 1 246 71 255 255 134 119 255 255 254 119 255 255 254 112 0 0 6 127 255 255 250 127 255 255 252 0 0 0 0 255 255 255 255 ])</body>

<body package="UIPainter" selector="CGAppFinder24">CGAppFinder24
	"UIMaskEditor new openOnClass: self andSelector: #CGAppFinder24"

	&lt;resource: #image&gt;
	^CachedImage on: (Image extent: 24@24 depth: 3 bitsPerPixel: 4 palette: (MappedPalette withColors: ((Array new: 8) at: 1 put: ColorValue black; at: 2 put: (ColorValue scaledRed: 4369 scaledGreen: 4369 scaledBlue: 4369); at: 3 put: (ColorValue scaledRed: 6553 scaledGreen: 6553 scaledBlue: 6553); at: 4 put: (ColorValue scaledRed: 3822 scaledGreen: 3822 scaledBlue: 3822); at: 5 put: ColorValue white; at: 6 put: ColorValue cyan; at: 7 put: ColorValue yellow; at: 8 put: ColorValue blue; yourself)) usingBits: (ByteArray fromPackedString: 'H"H"H"H"H"H"H"H"H@@@@@@@@@@@@@@BHEIRT%H%IRIRT%TBH@L@@@@@@@@@@@HBH@A7]7]7]7]7]0TBHE@C@@@@@@@@@@HBHB@ Y&amp;Y&amp;Y&amp;Y&amp;Y TBHEHBA&amp;Y&amp;Y&amp;Y&amp;Y HBHBTDHCL3L3M#M TBHEHBP QDMDM#M HBHBTDIB@3L3M&amp;Y TBHEIPP$HDMDM#M HBHBT QBP L3M#M TBHEIPQDIBADM&amp;Y HBHBT IDP$HDM#M TBHEIPH$QBP M#M HBHBT H"QDIBA&amp;Y HBHEIP@@@@P$HFY TBHBT%HQDQ@@P Y HBHEIRT%H%DQ@BA TBHBT%IRURT%DP@EHBHEIRT%H%IRIQD@TBH@@@@@@@@@@@@@@BH"H"H"H"H"H"H"H"'))</body>

<body package="DLLCC" selector="CGExtFinder24">CGExtFinder24
	"UIMaskEditor new openOnClass: self andSelector: #CGExtFinder24"

	&lt;resource: #image&gt;
	^CachedImage on: (Image extent: 24@24 depth: 4 bitsPerPixel: 4 palette: (MappedPalette withColors: ((Array new: 9) at: 1 put: ColorValue black; at: 2 put: (ColorValue scaledRed: 3276 scaledGreen: 3276 scaledBlue: 3276); at: 3 put: ColorValue white; at: 4 put: (ColorValue scaledRed: 4112 scaledGreen: 4112 scaledBlue: 4112); at: 5 put: ColorValue cyan; at: 6 put: ColorValue lightGray; at: 7 put: ColorValue yellow; at: 8 put: (ColorValue scaledRed: 0 scaledGreen: 0 scaledBlue: 4112); at: 9 put: ColorValue red; yourself)) usingBits: (ByteArray fromPackedString: '@@@@@@@@@@@@@@@@ADQDQDQDQDQDQDQ@@0@@@@@@@@@@@@A@@2@ H"HB@ H"HBA@@2@@@@@@@@@@@@A@AR@FI"X&amp;I"X&amp;I"A@@2@RX&amp;I"]7]"X&amp;A@@2@3@RX'']7]6I"A@AR@2@!I''\&amp;]2X&amp;A@@2@2@2D'']"X&amp;I"A@@2@2@#HW\&amp;I"X&amp;A@AR@2@2T'']"X&amp;I"A@@2@2@#H7\&amp;I"X&amp;A@@2@@@2L''\R]6I"A@AR@H@#H7]7]2X&amp;A@@2@H@2L#]7\&amp;I"A@@@@@@#H2L%HRX&amp;A@@H@Q@@@@@@@@I"A@@@@2DQDQDQDQD@A@@Q@5L3L3L3L3L3Q@@2@@@@@@@@@@@@A@@3DQDQDQDQDQDQE@@@@@@@@@@@@@@@@@L3L3L3L3L3L3L3L3'))</body>

<body package="DLLCC" selector="CGExtFinder32">CGExtFinder32
	"UIMaskEditor new openOnClass: self andSelector: #CGExtFinder32"

	&lt;resource: #image&gt;
	^CachedImage on: (Image extent: 32@32 depth: 4 bitsPerPixel: 4 palette: (MappedPalette withColors: ((Array new: 9) at: 1 put: ColorValue black; at: 2 put: (ColorValue scaledRed: 3276 scaledGreen: 3276 scaledBlue: 3276); at: 3 put: ColorValue white; at: 4 put: (ColorValue scaledRed: 4112 scaledGreen: 4112 scaledBlue: 4112); at: 5 put: ColorValue cyan; at: 6 put: ColorValue lightGray; at: 7 put: ColorValue yellow; at: 8 put: (ColorValue scaledRed: 0 scaledGreen: 0 scaledBlue: 4112); at: 9 put: ColorValue red; yourself)) usingBits: (ByteArray fromPackedString: '@@@@@@@@@@@@@@@@@@@@@@ADQDQDQDQDQDQDQDQDQD@CADQDQDQDQDQDQDQDQDQ@@3ADQDQDQDQDQDQDQDQDP@L2@@@@@@@@@@@@@@@@AD@CL HBH"HB@ HB@"H"@ Q@@3H@@@@@@@@@@@@@@@@DP@T2@FI"X&amp;I"X&amp;I"X&amp;I"AD@CL HVI"X&amp;I"X&amp;I"X&amp;I Q@@3HBL0E"X&amp;]7]7]&amp;X&amp;HDP@L2@#HCE"Y7]7]7]"X&amp;AD@EL H2@#E"]7]7]7I"X Q@@3HBL L#E'']6I'']6I"XDP@L2@#HBL#E7\&amp;I"X&amp;I"AD@CL H2@2L#]7X&amp;I"X&amp;I Q@ASHBL H2T'']2X&amp;I"X&amp;XDP@L2@#HCH2M7]"X&amp;I"X&amp;AD@CL H2@#H2]7E"]7I"X Q@@3HB@@L#H7]7]7]6I"XDP@T2@  BT#I7]7]7\&amp;I"AD@CL HH@2L#I7]7]2X&amp;I Q@@0@B@@H2T#H2L#E"X&amp;HDP@LH@!DCH2L%H2T#E"X&amp;AD@CB@H2@@@@@@@@@@I"X Q@@0@BL1DQDQDQDQDQD@@DP@LQ@#L1DQDQDQDQDQDTQD@CL H5L3L3L3L3L3L1DTQ@@3H@@@@@@@@@@@@@@@@DP@L3DQDQDQDQDQDQDQDQDD@CMSL3L3L3L3L3L3L3L3L@@@@@@@@@@@@@@@@@@@@@@EUUUUUUUUUUUUUUUUUUUUTb'))</body>

<body package="Tools-Misc" selector="launcherToolBar">launcherToolBar
	"Tools.MenuEditor new openOnClass: self andSelector: #launcherToolBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #saveImage 
					#defaultString: 'Save image' 
					#catalogID: #labels ) 
				#value: #imageSave 
				#labelImage: #(#{UI.ResourceRetriever} #{ToolbarIconLibrary} #fileSave ) 
				#helpText: 
				#(#{Kernel.UserMessage} 
					#key: #SaveTheVisualWorksImage 
					#defaultString: 'Save the VisualWorks Image' 
					#catalogID: #menus ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #browseSystem 
					#defaultString: 'Browse System' 
					#catalogID: #menus ) 
				#nameKey: #systemButton 
				#value: #browseSystem 
				#labelImage: #(#{UI.ResourceRetriever} #{ToolbarIconLibrary} #systemBrowser ) 
				#helpText: 
				#(#{Kernel.UserMessage} 
					#key: #OpenASystemBrowser 
					#defaultString: 'Open a System Browser' 
					#catalogID: #menus ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #BrowseClassVariableNameSpace 
					#defaultString: 'Browse Class/Variable/Name Space' 
					#catalogID: #menus ) 
				#value: #browseGlobalName 
				#labelImage: #(#{UI.ResourceRetriever} #{ToolbarIconLibrary} #findClass ) 
				#helpText: 
				#(#{Kernel.UserMessage} 
					#key: #BrowseClassVariableNameSpaceDots 
					#defaultString: 'Browse Class/Variable/Name Space...' 
					#catalogID: #menus ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #BrowseSendersOf 
					#defaultString: 'Browse Senders Of' 
					#catalogID: #menus ) 
				#value: #browseSendersOf 
				#labelImage: #(#{UI.ResourceRetriever} #{ToolbarIconLibrary} #selectorReferences ) 
				#helpText: 
				#(#{Kernel.UserMessage} 
					#key: #BrowseSendersOfSelector 
					#defaultString: 'Browse Senders of Selector...' 
					#catalogID: #menus ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #BrowseImplementorsOf 
					#defaultString: 'Browse Implementors Of' 
					#catalogID: #menus ) 
				#value: #browseImplementorsOf 
				#labelImage: #(#{UI.ResourceRetriever} #{ToolbarIconLibrary} #selectorImplementors ) 
				#helpText: 
				#(#{Kernel.UserMessage} 
					#key: #BrowseImplementors 
					#defaultString: 'Browse Implementors of Selector...' 
					#catalogID: #menus ) ) ) #(1 4 ) nil ) decodeAsLiteralArray</body>

<body package="cormas" selector="menuBar"></body>

<body package="Tools-Misc" selector="windowMenu">windowMenu
	"MenuEditor new openOnClass: self andSelector: #windowMenu"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: #(#{Kernel.UserMessage} #key: #_Toolbar #defaultString: '&amp;Toolbar' #catalogID: #menus) 
				#nameKey: #toolbar 
				#value: #toggleToolbar 
				#indication: true ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #refreshAll 
					#defaultString: 'Re&amp;fresh All' 
					#catalogID: #menus ) 
				#value: #winRefreshAll ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #collapseAll 
					#defaultString: '&amp;Collapse All' 
					#catalogID: #menus ) 
				#value: #winCollapseAll ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #restoreAll 
					#defaultString: '&amp;Restore All' 
					#catalogID: #menus ) 
				#value: #winRestoreAll ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #newLauncher 
					#defaultString: '&amp;New Launcher' 
					#catalogID: #menus ) 
				#value: #winNewLauncher ) ) #(1 3 1 ) nil ) decodeAsLiteralArray</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>accessing</category>

<body package="Tools-Misc" selector="checkInstalledComponents">checkInstalledComponents
	"Get all open Launchers to update their buttons, menus etc so
	 that they accurately reflect the current set of loaded components.
	 This is usually used on load and unload of any component that is
	 accessible via the Launcher."
	"VisualLauncher checkInstalledComponents"

	ScheduledWindow scheduledControllers do: 
		[:each | 
		(each model isKindOf: self) ifTrue: [each model enableConnections]]</body>

<body package="Tools-Misc" selector="raiseOrOpen">raiseOrOpen
	"This is used by the warp-to-launcher hot key feature
	which runs at priority 90. If opening a new launcher,
	make sure it runs at a more reasonable one."

	self raiseSingleInstance ifNil: 
		[[self open] forkAt: Processor userSchedulingPriority]</body>

<body package="Non-Commercialization" selector="title">title
	"Return a title for the launcher which includes the image name"

	^(#VWLauncherLabelNC &lt;&lt; #labels &gt;&gt; 'VisualWorks NonCommercial  &lt;1s&gt;') expandMacrosWith: ObjectMemory imagePrefix</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>private</category>

<body package="Tools-Misc" selector="addAll:toMenu:">addAll: labelsAndViews toMenu: aMenu

	labelsAndViews keysAndValuesDo:
		[:index :each |
		aMenu addItem: (self menuItemFor: each at: index)]</body>

<body package="Tools-Misc" selector="addCurrentWindowsTo:">addCurrentWindowsTo: aMenu
	"Add items for all VisualWorks windows to aMenu. The window 
	selected by the user will be expanded, if necessary, and brought to 
	front."

	| labelsAndViews |
	labelsAndViews := self currentWindowLabelsAndViews.
	labelsAndViews size &lt; 10
		ifTrue: [self addAll: labelsAndViews toMenu: aMenu]
		ifFalse: [self addNine: labelsAndViews toMenu: aMenu]</body>

<body package="Tools-Misc" selector="addNine:toMenu:">addNine: labelsAndViews toMenu: aMenu
 
	| partial |
	partial := labelsAndViews copyFrom: 1 to: 9.
	partial keysAndValuesDo: 
		[:index :each |
		aMenu addItem: (self menuItemFor: each at: index)].
	aMenu
		addLine;
		addItem: ((MenuItem labeled: (#_0MoreWindows &lt;&lt; #dialogs &gt;&gt; '&amp;0. More Windows...')) 
					value: [self selectAndRaiseViewAmong: labelsAndViews])</body>

<body package="Tools-Misc" selector="addTo:label:forClass:openWith:">addTo: aMenu label: aString forClass: aClassIdentifier openWith: anOpeningSymbol

	| mi |
	mi := MenuItem labeled: aString.
	mi enabled: [aClassIdentifier asQualifiedReference isDefined].
	aMenu addItem: mi value: [aClassIdentifier asQualifiedReference value perform: anOpeningSymbol]</body>

<body package="Tools-Misc" selector="bringToFront:">bringToFront: view 

	view isCollapsed ifTrue: [view expand].
	^view raise</body>

<body package="Tools-Misc" selector="buildWindowMenu">buildWindowMenu

	| menu |
	menu := self windowMenu.
	menu addLine.
	self addCurrentWindowsTo: menu.
	(menu atNameKey: #toolbar) ifNotNil:
		[:item | item indicationSelector: #toolbarVisible].
	^menu</body>

<body package="Tools-Misc" selector="classNameInitials:">classNameInitials: anObject

	^anObject class name select: [:each | each isUppercase]</body>

<body package="Tools-Misc" selector="currentWindowLabelsAndViews">currentWindowLabelsAndViews

	| labelsAndViews |
	labelsAndViews := OrderedCollection new.
	ScheduledWindow scheduledControllers do: 
		[:each | 	
		[(each model isKindOf: self) ifFalse: 
			[labelsAndViews add: each view label asString -&gt; each view]]
				on: Object errorSignal 
				do: [:error | error return]].
	labelsAndViews := labelsAndViews asSortedCollection: [:first :next | first key &lt;= next key].
	^labelsAndViews asArray</body>

<body package="Tools-Misc" selector="hasAdvancedTools">hasAdvancedTools

	^#{TimeProfiler} isDefined
		or: [#{AllocationProfiler} isDefined
		or: [#{OEProfiler} isDefined
		or: [#{ClassReporter} isDefined
		or: [#{SystemBenchmark} isDefined
		or: [#{ProjectBrowser} isDefined
		or: [#{FullBrowserTabApplication} isDefined
			]]]]]]</body>

<body package="Tools-Misc" selector="menuItemFor:at:">menuItemFor: labelViewAssociation at: anInteger

	| label |
	label := '&amp;&lt;1p&gt;. [&lt;2s&gt;] &lt;3s&gt;'
		expandMacrosWith: anInteger
		with: (self classNameInitials: labelViewAssociation value model)
		with: labelViewAssociation key.
	^(MenuItem labeled: (label contractTo: 70))
		value: [self bringToFront: labelViewAssociation value]</body>

<body package="Tools-Misc" selector="openHelpBrowser">openHelpBrowser

	#{VWHelp.HelpBrowser}
		ifDefinedDo: [:helpBrowser | helpBrowser open]
		elseDo:
			[ | loadMessage |
			loadMessage := (#helpNotLoadedSuggestToLoad &lt;&lt; #dialogs &gt;&gt; 
				'VWHelp parcel is not loaded. Load it now?') expandMacros.
			(Dialog confirm: loadMessage) ifTrue:
				[[Notice 
					show: (#LoadingParcelN1S &lt;&lt; #dialogs &gt;&gt; 'Loading Parcel&lt;n&gt;&lt;1s&gt;' expandMacrosWith: 'VWHelp')
					while: [Parcel ensureLoadedParcel: 'VWHelp' withVersion: String new]]
					on: Parcel missingParcelSignal
					do: [:ex |
						^Dialog warn: (#helpParcelNotFound &lt;&lt; #dialogs &gt;&gt;
							'The VWHelp parcel could not be located.&lt;n&gt;Check that the VisualWorks home directory is set properly&lt;n&gt;and that the parcel is in the parcel path.') expandMacros].
					self openHelpBrowser]]</body>

<body package="Tools-Misc" selector="regenerateAdvancedMenu">regenerateAdvancedMenu
	"Reconstruct the Advanced Tools shared menu, if it's nil.  In either case, reset which elements are and are not enables.  This message should be sent after filing in any launchable APOK file."


	| menu pmenu pitem|
	pmenu := Menu new.
	self  addTo: pmenu label: (#ATTime &lt;&lt; #menus &gt;&gt; 'Time') forClass: #{TimeProfiler} openWith: #openView.
	self  addTo: pmenu label: (#ATAllocations &lt;&lt; #menus &gt;&gt; 'Allocations') forClass: #{AllocationProfiler} openWith: #openView.
	self  addTo: pmenu label: (#ATMultiTime &lt;&lt; #menus &gt;&gt; 'MultiTime') forClass: #{MultiTimeProfiler} openWith: #openView.
	self  addTo: pmenu label: (#ATMultiAllocations &lt;&lt; #menus &gt;&gt; 'MultiAllocations') forClass: #{MultiAllocationProfiler} openWith: #openView.
	self  addTo: pmenu label: (#ATObjectEngine &lt;&lt; #menus &gt;&gt; 'Object engine') forClass: #{OEProfiler} openWith: #open.
	#{BenchmarkRunner} isDefined ifTrue:
		[self  addTo: pmenu label: (#ATbenchmarkRunner &lt;&lt; #menus &gt;&gt; 'Benchmark runner') forClass: #{BenchmarkRunner} openWith: #open].
	pitem := MenuItem labeled: (#ATProfiles &lt;&lt; #menus &gt;&gt; 'Profiles').
	pitem enabled: [#{TimeProfiler} isDefined
						or: [#{AllocationProfiler} isDefined
							or: [#{OEProfiler} isDefined
								or: [#{BenchmarkRunner} isDefined]]]].
	pitem submenu: pmenu.
	menu := Menu new.
	menu addItem: pitem.
	self addTo: menu label: (#ATClassReports &lt;&lt; #menus &gt;&gt; 'Class reports') forClass: #{ClassReporter} openWith: #open.
	self addTo: menu label: (#ATBenchmarks &lt;&lt; #menus &gt;&gt; 'Benchmarks') forClass: #{SystemBenchmark} openWith: #open.
	#{ProjectBrowser} isDefined
		ifTrue:
			[self addTo: menu label: (#ATProjectBrowser &lt;&lt; #menus &gt;&gt; 'Project browser') forClass: #{ProjectBrowser} openWith: #open].
	self addTo: menu label: (#ATFullBrowser &lt;&lt; #menus &gt;&gt; 'Full browser') forClass: #{FullNotebookSystemBrowser} openWith: #openOnSystemFull.
	self addTo: menu label: (#ATCodingAssistant &lt;&lt; #menus &gt;&gt; 'Coding assistant') forClass: #{CodingAssistant} openWith: #open.
	^menu</body>

<body package="Tools-Misc" selector="selectAndRaiseViewAmong:">selectAndRaiseViewAmong: labelsAndViews

	| choice |
	choice := Dialog
		choose: (#SwitchToWindowC &lt;&lt; #dialogs &gt;&gt; 'Switch to window:')
		fromList: (labelsAndViews collect: [:each | each key])
		values: (labelsAndViews collect: [:each | each value])
		lines: 20
		cancel: [^self].
	self bringToFront: choice</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>interface opening</category>

<body package="Tools-Misc" selector="open">open
	^[super open]
		on: GetWindowManagerUsagePolicy
		do: [:ex | ex resume: MakeNewWindowManagerUsagePolicy new]</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>private-interface building</category>

<body package="UIPainter" selector="markedAsSystemClass">markedAsSystemClass
	"This class not to be shown when browsing user classes."</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher class</class-id> <category>cormas icons</category>

<body package="cormas" selector="cormasIcon"></body>

<body package="cormas" selector="englishIcon"></body>

<body package="cormas" selector="frenchIcon"></body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>Tools.VisualLauncher</class-id>
<body>VisualLauncher provides complete and convenient access to the VisualWorks functionality. It enables user  to save the image, change system settings, access Smalltalk programming tools, start up Data Base application development tools, UIPainter and its auxiliary tools, manage multiple windows and access the VW Online Documentation.

VisualLauncher open

Instance Variables:
	menuBar			&lt;Menu&gt; The menu for the main window of VisualWorks launcher. A convenient way to access menu items.
	toolBar				&lt;ValueHolder&gt; The tool bar of buttons.
	textCollector		&lt;TextCollector&gt;	the text collector to be used.
	toolDock	&lt;VisualLauncherToolDock&gt; The subapplication managing the status bar of the launcher.</body>
</comment>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>initialize-release</category>

<body package="Tools-Misc" selector="initialize">initialize

	super initialize.
	toolBar := nil asValue.</body>

<body package="Tools-Misc" selector="winNewLauncher">winNewLauncher
	"Create a new launcher."

	self class open.
	self closeAndUnschedule.
	self release</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>actions</category>

<body package="Tools-Misc" selector="browseAmbiguousReferences">browseAmbiguousReferences
	&lt;menuItem: #browseAmbiguousReferencesLabel
		nameKey: nil
		menu: #(#menuBar #browse)
		position: 25.5&gt;
	| mc calls |
	mc := MethodCollector new.
	calls := mc methodsSelect:
					[:m|
					[m allLiteralsDo:
						[:lit|
						lit isBindingReference
							ifTrue: [lit bindingOrNil]
							ifFalse:
								[(lit isVariableBinding and: [lit isDeferred]) ifTrue:
									[lit resolveBinding]]].
					 false]
						on: DuplicateBindingsError
						do: [:ex| ex return: true]].
	calls := Cursor execute showWhile: [calls select].
	DuplicateBindingsError ambiguousReferencesExist: calls size &gt; 0.
	mc
		openListBrowserOn: calls
		label: (#AmbiguousBindings &lt;&lt; #dialogs &gt;&gt; 'Ambiguous Binding References (accept to discover)')
		initialSelection: nil</body>

<body package="UIPainter" selector="browseApplications">browseApplications
	"Open a new UIFinder."
	&lt;menuItem: #(#BrowseApplications #UIPainter 'Browse Applications')
		icon: #finderIcon
		nameKey: nil
		menu: #(#launcherToolBar)
		position: 25.02
		helpText: #(#OpenAResourceFinder #UIPainter 'Open a Resource Finder')&gt;
	&lt;menuItem: #(#_ResourceFinder #UIPainter '&amp;Resource Finder')
		icon: #finderIcon
		nameKey: nil
		menu: #(#menuBar painter)
		position: 20.1&gt;

	self openApplicationForClassNamed: #{UIFinderVW2}</body>

<body package="Tools-Misc" selector="browseGlobal">browseGlobal
	"Browse references to a global variable (either in Smalltalk or Undeclared).
	 Try to track down references that go through the global's name as well as
	 direct references via its association."

	self applicationForClassNamed: #{SmalltalkWorkbench}
		do: [:class| class browseGlobalFrom: builder window]</body>

<body package="Tools-Misc" selector="browseGlobalName">browseGlobalName
	"Open a browser on a class, shared variable, or a namespace after
	having the user select it in an incremental search dialog"

	self applicationForClassNamed: #{SmalltalkWorkbench}
		do: [:class| class promptThenBrowseGlobalNameFrom: builder window]</body>

<body package="Tools-Misc" selector="browseImplementorsOf">browseImplementorsOf

	self applicationForClassNamed: #{SmalltalkWorkbench}
		do: [:class| class promptThenBrowseImplementorsFrom: builder window]</body>

<body package="Tools-Misc" selector="browseInspect">browseInspect
	"Inspect a global variable (either in Smalltalk or Undeclared).
	 Try to track down references that go through the global's name as well as
	 direct references via its association."

	self applicationForClassNamed: #{SmalltalkWorkbench}
		do: [:workbench| | answer |
		answer := workbench pickASomething: (#InspectSharedVariableNamedColon &lt;&lt; #dialogs &gt;&gt; 'Inspect Shared Variable Named:').
		answer = '' ifTrue: [^self].
		( answer == false or: [answer == nil] )
			ifTrue: [ Dialog warn: (#VariableDoesNotExist &lt;&lt; #dialogs &gt;&gt; 'Variable does not exist') ] 
			ifFalse:
				[answer isBindingReference ifFalse: [answer := answer fullyQualifiedReference].
				answer value inspect]]</body>

<body package="Tools-Misc" selector="browseSendersOf">browseSendersOf

	self applicationForClassNamed: #{SmalltalkWorkbench}
		do: [:class| class promptThenBrowseCallsFrom: builder window]</body>

<body package="Tools-Misc" selector="browseSystem">browseSystem

	self openApplicationForClassNamed: #{Refactory.Browser.RefactoringBrowser}</body>

<body package="Tools-Changes" selector="browseSystemOverrides">browseSystemOverrides

	&lt;menuItem: #(#browseSystemOverrides #menus 'Browse &amp;System Overrides')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #system changes)
		position: 30.04&gt;

	OverrideList new openOn: Override overrideList</body>

<body package="Tools-Misc" selector="changesFileCondense">changesFileCondense
	(Dialog confirm: (#verifyCondense &lt;&lt; #dialogs &gt;&gt; 'Really condense the changes file?')) ifTrue: [
		SourceFileManager default condenseChanges]</body>

<body package="Tools-Changes" selector="changesOpenChangeList">changesOpenChangeList
	&lt;menuItem: #(#_ChangeList #menus '&amp;Change List')
		icon: nil
		nameKey: nil
		shortcutKeyCharacter: #F7
		shortcutModifiers: 0
		menu: #(#menuBar tools)
		position: 9.02&gt;

	self openApplicationForClassNamed: #{ChangeList}</body>

<body package="Tools-Changes" selector="changesOpenChangeSets">changesOpenChangeSets
	&lt;menuItem: #(#openChangeSets #menus 'Change &amp;Sets')
		icon: nil
		nameKey: nil
		shortcutKeyCharacter: #F4
		shortcutModifiers: 0
		menu: #(#menuBar system changes)
		position: 10.001&gt;

	self openApplicationForClassNamed: #{ChangeSetManager}</body>

<body package="Tools-Misc" selector="clearTranscript">clearTranscript

	self textCollector clear</body>

<body package="Tools-Misc" selector="collectAllGarbage">collectAllGarbage
	ObjectMemory verboseGlobalCompactingGC</body>

<body package="Tools-Misc" selector="collectGarbage">collectGarbage
	ObjectMemory verboseCompactingGC</body>

<body package="Tools-Workspace" selector="fileOpen">fileOpen
	&lt;menuItem: #(#OpenFileItemLabel #menus '&amp;Open File...')
		icon: nil
		nameKey: #fileOpen
		menu: #(#menuBar file)
		position: 9.02&gt;

	| name ws |
	name := (Dialog requestFileName: (#OpenFile &lt;&lt; #dialogs &gt;&gt; 'Open File') default: '*.ws') trimBlanks.
	name isEmpty ifFalse:
		[ws := Workspace withFile: name.
		 ws encodingChannel value: #default.
		 ws open]</body>

<body package="Tools-Misc" selector="filePermSaveAs">filePermSaveAs
	ObjectMemory permSaveDialogThenQuit: false.
	self builder window label: self class title</body>

<body package="Tools-Misc" selector="filePermUndoAs">filePermUndoAs
	ObjectMemory permUndoDialogThenQuit: false.
	self builder window label: self class title</body>

<body package="Tools-Misc" selector="helpAbout">helpAbout
	"Display the dialog containing the version identification and
	 copyright notice."

	AboutVisualWorksDialog open</body>

<body package="Non-Commercialization" selector="helpGettingStartedWorkspace">helpGettingStartedWorkspace
	&lt;menuItem: #(#gettingStartedWorkspace #menus 'Getting Started Workspace...')
		nameKey: nil
		menu: #(#menuBar #help)
		position: 6.01&gt;
	
	Workspace openGettingStartedWorkspace.</body>

<body package="Tools-Workspace" selector="helpInstallationWorkspace">helpInstallationWorkspace
	&lt;menuItem: #(#installWorkspace #menus 'Installation Workspace')
		nameKey: nil
		menu: #(#menuBar #help)
		position: 5.02&gt;

	Workbook systemWorkbook
		open;
		selectPageLabeled: 
			(#installationWorkspace &lt;&lt; #labels &gt;&gt; 'Installation Workspace')</body>

<body package="Non-Commercialization" selector="helpIvanTomekWorkspace">helpIvanTomekWorkspace
	&lt;menuItem: #(#ivanTomekWorkspace #menus 'Introductory Workspace...')
		nameKey: nil
		menu: #(#menuBar #help)
		position: 6.03&gt;
	
	Workspace openIvanTomekWorkspace.</body>

<body package="SLesson Base" selector="helpLessonRunner">helpLessonRunner
	&lt;menuItem: #(#lessonBrowser #menus 'Lesson Browser')
		nameKey: nil
		menu: #(#menuBar #help)
		position: 5.03&gt;
	
	LessonRunner open</body>

<body package="Tools-Misc" selector="helpLoadHelp">helpLoadHelp
	&lt;menuItem: #(#loadHelp #menus 'Load &amp;Help')
		icon: #helpIcon
		nameKey: nil
		menu: #(#menuBar #help)
		position: 4.01&gt;
	Notice 
		show: (#LoadingParcelN1S &lt;&lt; #dialogs &gt;&gt; 'Loading Parcel&lt;n&gt;&lt;1s&gt;' expandMacrosWith: 'VWHelp')
		while: [Parcel ensureLoadedParcel: 'VWHelp' withVersion: '']</body>

<body package="Non-Commercialization" selector="helpNoncommercialWorkspace">helpNoncommercialWorkspace
	&lt;menuItem: #(#helpNoncommercialWorkspace #menus 'Features Workspace...')
		nameKey: nil
		menu: #(#menuBar #help)
		position: 6.02&gt;
	
	Workspace openNonCommercialWorkspace.</body>

<body package="Tools-Misc" selector="helpObjectReference">helpObjectReference
	&lt;menuItem: #(#objectReferenceMenu #menus 'Object Reference')
		nameKey: nil
		menu: #(#menuBar #help)
		position: 5.01&gt;
	| objectReference text list b table |
	objectReference := Dictionary new.
	Cursor wait showWhile:
		[SystemUtils allClassesDo:
			[:class | | comment index str |
			str := 'Object Reference:'.
			(index := (comment := class comment) indexOfSubCollection: str startingAt: 1) &gt; 0 ifTrue:
				[index := index + str size.
				[(comment at: index) isSeparator] whileTrue: [index := index + 1].
				objectReference at: class fullName put: (comment copyFrom: index to: comment size)]]].
	text := '' asValue.
	list := SelectionInList new.
	list list: (table := objectReference keys asSortedStrings asArray).
	list selectionIndexHolder: ((PluggableAdaptor on: 0 asValue)
							getBlock: [:m | m value]
							putBlock:
								[:m :v |
								m value: v.
								text value: (v = 0
											ifTrue: ['']
											ifFalse: [objectReference at: (table at: v)])]
							updateBlock: [:m :a :p | false ];
							yourself).
	list selectionIndex: 0.
	b := UIBuilder new.
	b
		add: ((WindowSpec label: (#objectReferenceLabel &lt;&lt; #labels &gt;&gt; 'Object Reference')) min:300@350; yourself);
		add: (SequenceViewSpec model: list layout: ((LayoutFrame new) rightFraction: 1; bottomFraction: 0.3));
		add: (TextEditorSpec model: text layout: ((LayoutFrame new) rightFraction: 1; topFraction: 0.3; bottomFraction: 1)).
	b open</body>

<body package="Tools-Workspace" selector="helpSystemWorkspace">helpSystemWorkspace
	&lt;menuItem: #(#systemWorkspaceMenu #menus 'System Workspace')
		nameKey: nil
		menu: #(#menuBar #help)
		position: 5.03&gt;

	Workbook systemWorkbook
		open;
		selectPageLabeled: 	
			(#systemWorkspace &lt;&lt; #labels &gt;&gt; 'System Workspace')</body>

<body package="Tools-Misc" selector="imageSave">imageSave

	ObjectMemory snapshot.
	self builder window label: self class title</body>

<body package="Tools-Misc" selector="imageSaveAs">imageSaveAs
	ObjectMemory saveDialogThenQuit: false.
	self builder window label: self class title</body>

<body package="Tools-Misc" selector="inspectDependentsFields">inspectDependentsFields

	&lt;menuItem: #inspectDependentsFieldsLabel
		nameKey: nil
		menu: #(menuBar browse inspect)
		position: 15.0&gt;
	DependentsFields inspect</body>

<body package="Tools-Misc" selector="inspectProcessor">inspectProcessor

	Processor inspect</body>

<body package="Tools-Misc" selector="inspectScheduledControllers">inspectScheduledControllers

	ScheduledControllers scheduledControllers inspect</body>

<body package="Tools-Misc" selector="inspectUndeclared">inspectUndeclared

	&lt;menuItem: #inspectUndeclaredLabel
		nameKey: nil
		menu: #(menuBar browse inspect)
		position: 15.1&gt;
	Undeclared inspect</body>

<body package="Lens-Dev" selector="newDataForm">newDataForm
	"Create the new data form and then give the oportunity to immediately define a canvas for it"

	self applicationForClassNamed: #UIFinderVW2
		do:
		[:uiFinder| | newClass cl |
		cl := #{LensApplicationSpecEditor} valueOrDo: [^self].
		newClass := uiFinder
						createNewApplication: nil
						ofKind: #LensDataManager
						inCategory: nil
						forClient: self.
		cl new openDialogForClass: newClass]</body>

<body package="Lens-Dev" selector="newDataMain">newDataMain
	"Create a new database application and then open a painter on its canvas"

	self applicationForClassNamed: #UIFinderVW2
		do:
		[:uiFinder| | newClass |
		newClass := uiFinder
						createNewApplication: nil
						ofKind: #LensMainApplication
						inCategory: nil
						forClient: self.
		newClass notNil ifTrue:
			[self applicationForClassNamed: #UIPainter
				do: [:uiPainter| uiPainter new openOnClass: newClass andSelector: #windowSpec]]]</body>

<body package="Tools-Misc" selector="openAdHocQuery">openAdHocQuery
	self openApplicationForClassNamed: #{AdHocQueryTool}</body>

<body package="Tools-Misc" selector="openCanvasComposer">openCanvasComposer

	| panGen sc cl |
	cl := #{LensApplicationSpecEditor} valueOrDo: [^self].
	sc := #{LensApplicationSpec} valueOrDo: [^self].
	panGen := cl new.
	panGen spec: sc new.
	panGen open</body>

<body package="Lens-Dev" selector="openDataModelBrowser">openDataModelBrowser 
	&lt;menuItem: #(#BrowseDataModels #lensDev 'Browse Data Models')
		icon: #dbToolIcon
		nameKey: nil
		menu: #(#launcherToolBar)
		position: 25.03&gt;

	self openApplicationForClassNamed: #{LensEditor}</body>

<body package="DLLCC" selector="openExternalFinder">openExternalFinder
	&lt;menuItem: #(#BrowseExternals #dllcc 'Browse Externals')
		icon: #extFinderIcon
		nameKey: nil
		menu: #(#launcherToolBar)
		position: 20.04
		helpText: #(#DLLAndCConnect #dllcc 'DLL and C Connect')&gt;

	self openApplicationForClassNamed: #{ExternalInterfaceFinder}</body>

<body package="Tools-File Browser" selector="openFileBrowser">openFileBrowser
	&lt;menuItem: #(#fileBrowser #menus 'File Browser' )
		icon: #fileBrowser
		nameKey: #openParcelManager
		menu: #(#launcherToolBar)
		position: 30.01
		helpText: #(#OpenAFileBrowser #menus 'Open a File Browser')&gt;
	&lt;menuItem: #(#FileBrowserLabel #menus '&amp;File Browser')
		icon: #fileBrowser
		nameKey: nil
		shortcutKeyCharacter: #F2
		shortcutModifiers: 0
		menu: #(#menuBar file)
		position: 9.01&gt;

	self openApplicationForClassNamed: #{Tools.FileTools.FileBrowser}</body>

<body package="UIPainter" selector="openHotRegionsEditor">openHotRegionsEditor
	&lt;menuItem: #(#_HotRegionsEditor #UIPainter '&amp;Hot Regions Editor')
		nameKey: nil
		menu: #(#menuBar #painter)
		position: 10.91&gt;

	self applicationForClassNamed: #{UIHotRegionEditor} do: [:class| class open]</body>

<body package="Tools-Changes" selector="openOverrideList">openOverrideList

	&lt;menuItem: #(#openOverrideList #menus 'Open &amp;Override List')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #system changes)
		position: 30.02&gt;

	OverrideList open</body>

<body package="Tools-Parcel Manager" selector="openParcelManager">openParcelManager
	"Open a new ParcelManager." 
	&lt;menuItem: #(#ParcelManager #menus 'Parcel Manager')
		icon: #cardfile
		nameKey: #openParcelManager
		menu: #(#launcherToolBar)
		position: 10.01
		helpText: #(#OpenAParcelManager #menus 'Open a Parcel Manager')&gt;
	&lt;menuItem: #(#_ParcelManager #menus '&amp;Parcel Manager')
		icon: #cardfile
		nameKey: nil
		shortcutKeyCharacter: #F3
		shortcutModifiers: 0
		menu: #(#menuBar system)
		position: 9.01&gt;

	self openApplicationForClassNamed: #{ParcelManager}</body>

<body package="PDPProcessMonitor" selector="openProcessMonitor">openProcessMonitor
	&lt;menuItem: #(#OpenProcess_Monitor #pdp 'Open Process &amp;Monitor')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes)
		position: 100&gt;
	ProcessMonitorService open</body>

<body package="UIPainter" selector="painterMenu">painterMenu
	&lt;submenu: #(#_Painter #UIPainter '&amp;Painter')
		nameKey: #painter
		menu: #(menuBar)
		position: 10.034&gt;</body>

<body package="Tools-Settings-VW" selector="setVisualWorksHome">setVisualWorksHome
	"VisualLauncher someInstance setVisualWorksHome"
	&lt;menuItem: #(#_SetVisualWorksHome #menus '&amp;Set VisualWorks Home...' )
		nameKey: nil
		menu: #(#menuBar file)
		position: 19.1&gt;

	VisualWorksSettings openManagerPage: #(system)</body>

<body package="Tools-Misc" selector="toggleToolbar">toggleToolbar

	builder window toolbarVisible: builder window toolbarVisible not</body>

<body package="Tools-Misc" selector="toolsLoadParcelByName">toolsLoadParcelByName

	&lt;menuItem: #(#loadParcelNamed #menus '&amp;Load Parcel Named...')
	nameKey: nil
	menu: #(#menuBar #tools)
	position: 15.2&gt;

	^Parcel loadParcelByNameFor: self mainWindow</body>

<body package="UIPainter" selector="toolsMaskEditor">toolsMaskEditor
	"Open mask editor."
	&lt;menuItem: #(#_ImageEditor #UIPainter '&amp;Image Editor')
		nameKey: nil
		menu: #(#menuBar painter)
		position: 10.50&gt;

	self openApplicationForClassNamed: #{UIMaskEditor}</body>

<body package="UIPainter" selector="toolsMenuEditor">toolsMenuEditor
	"Open menu editor."
	&lt;menuItem: #(#_MenuEditor #UIPainter '&amp;Menu Editor')
		nameKey: nil
		menu: #(#menuBar painter)
		position: 10.10&gt;

	self openApplicationForClassNamed: #{MenuEditor}</body>

<body package="UIPainter" selector="toolsNewCanvas">toolsNewCanvas
	"Open a new Canvas."
	&lt;menuItem: #(#NewCanvas #UIPainter 'New Canvas')
		icon: #newCanvasIcon
		nameKey: nil
		menu: #(#launcherToolBar)
		position: 25.01
		helpText: #(#EditANewCanvas #UIPainter 'Edit a New Canvas')&gt;
	&lt;menuItem: #(#_NewCanvas #UIPainter '&amp;New Canvas')
		icon: #newCanvasIcon
		nameKey: nil
		menu: #(#menuBar painter)
		position: 5.0&gt;

	self applicationForClassNamed: #{UIPainter} do: [:class| class new openNewWindowCanvas]</body>

<body package="Tools-Workspace" selector="toolsNewWorkspace">toolsNewWorkspace
	"Open a new workspace."
	&lt;menuItem: #(#Workspace #labels 'Workspace')
		icon: #workspaceIcon
		nameKey: nil
		menu: #(#launcherToolBar)
		position: 30.5
		helpText: #(#OpenANewWorkspace #labels 'Open a new workspace')&gt;
	&lt;menuItem: #(#_Workspace #menus '&amp;Workspace')
		icon: #workspaceIcon
		nameKey: nil
		shortcutKeyCharacter: #F6
		shortcutModifiers: 0
		menu: #(#menuBar tools)
		position: 9.00&gt;

	self openApplicationForClassNamed:
		(AbstractWorkspace useMultiPageWorkspaces
			ifTrue: [#Workbook]
			ifFalse: [#Workspace])</body>

<body package="Tools-Misc" selector="toolsUnloadParcelByName">toolsUnloadParcelByName

	&lt;menuItem: #(#unloadParcelNamed #menus '&amp;Unload Parcel Named...')
	nameKey: nil
	menu: #(#menuBar #tools)
	position: 15.3&gt;

	^Parcel unloadParcelByNameFor: builder window</body>

<body package="Tools-Misc" selector="visualWorksExit">visualWorksExit
	ObjectMemory quitDialog</body>

<body package="Tools-Misc" selector="visualWorksLauncher">visualWorksLauncher
	 self class open</body>

<body package="Tools-Settings-VW" selector="visualWorksSettings">visualWorksSettings
	"Open a new Settings control panel."
	&lt;menuItem: #(#Settings #menus 'Settings')
		icon: #properties
		nameKey: #visualWorksSettings
		menu: #(#launcherToolBar)
		position: 10.02
		helpText: #(#EditTheSystemOptions #menus 'Edit the system options')&gt;
	&lt;menuItem: #(#settings #menus '&amp;Settings')
		icon: #properties
		nameKey: #visualWorksSettings
		menu: #(#menuBar system)
		position: 9.02&gt;


	SettingsManager 
		openOrRaise: VisualWorksSettings 
		selectPage: #()</body>

<body package="Tools-Misc" selector="winCollapseAll">winCollapseAll
	"Collapse (minimize) all windows under VisualWorks control except 
	for the launcher causing this 
	method to execute."

	| actController |
	actController := self builder window controller.
	ScheduledWindow scheduledControllers do: 
		[:each | 
		[each == actController ifFalse: [each collapse]] 
			on: Object errorSignal
			do: [:error | error return]]</body>

<body package="Tools-Misc" selector="winRefreshAll">winRefreshAll
	"Repaint all of the windows under VisualWorks control."

	WindowManager restoreAll</body>

<body package="Tools-Misc" selector="winRestoreAll">winRestoreAll
	"Expand (maximize) all of the windows under VisualWorks control."

	| win |
	win := Window currentWindow.
	ScheduledWindow scheduledWindows do:
		[:each |
		[each isCollapsed ifTrue: [each expand]]
			on: Object errorSignal 
			do: [:ex | ex return]].
	win raise.</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>changing</category>

<body package="Tools-Misc" selector="changeRequest">changeRequest
	"The receiver wants to change; check with all dependents that it is 
	OK."
	^self myDependents updateRequest and: [self closeDialog]</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>interface opening</category>

<body package="Tools-Misc" selector="postBuildWith:">postBuildWith: aBuilder 
	"Do anything you might want to do prior to the builder constructing a 
	canvas."

	super postBuildWith: aBuilder.
	builder window icon: (Icon constantNamed: #launcher).
	builder window application: self.
	builder window sendWindowEvents: #(#newGraphicsDevice #reopen).
	self enableConnections.
	(builder componentAt: #textViewID) widgetState canTakeFocus: true; isTabStop: true.
	aBuilder sendKeyboardTo: (builder componentAt: #textViewID) widget</body>

<body package="Tools-Misc" selector="postOpenWith:">postOpenWith: aBuilder 
	builder window windowManager activeControllerProcess 
		environmentAt: #WindowManagerUsagePolicy
		put: MakeNewWindowManagerUsagePolicy new.
	self changed: #newInterface.	
	self updateStatusBar</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>accessing</category>

<body package="Tools-Misc" selector="statusBarSubapplication">statusBarSubapplication
	"This method is called only once to the create the subapplication.
	Therefore, if there is an old one, we need to release it properly
	to make all the dependents go away."

	toolDock notNil ifTrue: [toolDock release].
	toolDock := VisualLauncherToolDock new.
	^toolDock</body>

<body package="Tools-Misc" selector="textCollector">textCollector

	textCollector == nil
		ifTrue: [textCollector := Transcript].
	^textCollector</body>

<body package="Tools-Misc" selector="textCollector:">textCollector: aTextCollector

	textCollector := aTextCollector</body>

<body package="Tools-Misc" selector="textView">textView
	"Conjure up a view for the system transcript in the Visual Launcher."

	| tcv |
	tcv := TextCollectorView new model: self textCollector.
	tcv controller: TextEditorController new.
	tcv controller initializeMenuForCode.
	tcv controller keyboardProcessor: builder keyboardProcessor.
	^tcv</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>menus</category>

<body package="Tools-Misc" selector="launcherToolBar">launcherToolBar

	self updateToolBar.
	^toolBar</body>

<body package="Tools-Misc" selector="newMenuBar">newMenuBar

	menuBar := self class fullMenuBar.
	menuBar isNil ifTrue: [^self].
	self rebuildMenu.
	^menuBar</body>

<body package="Tools-Misc" selector="updateToolBar">updateToolBar

	| menu |
	menu := self class launcherToolBar.
	menu
		augmentFrom: self class
		to: VisualLauncher
		menuName: #launcherToolBar.
	toolBar value: menu</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>private</category>

<body package="Tools-Misc" selector="applicationForClassNamed:do:">applicationForClassNamed: aSymbol do: aBlock
	"Evaluate aBlock with the class named aSymbol, if it exists.  If it
	 does not exist issue a warning."

	| cl |
	cl := aSymbol asQualifiedReference valueOrDo:
		[^Dialog warn: ((#warnClassNotInSystem &lt;&lt; #dialogs &gt;&gt; 'Class &lt;1s&gt; not in system.')
				expandMacrosWith: aSymbol asString)].
	^aBlock value: cl</body>

<body package="Tools-Misc" selector="browseAmbiguousReferencesLabel">browseAmbiguousReferencesLabel

	^(#AmbiguousReferencesExist &lt;&lt; #menus &gt;&gt; '&amp;Ambiguous References&lt;1? (exist):&gt;')
		expandMacrosWith: DuplicateBindingsError ambiguousReferencesExist</body>

<body package="Tools-Misc" selector="closeDialog">closeDialog
	"The Launcher is uncloseable if it is the last open window"

	| result labels values |
	labels := OrderedCollection new.
	values := OrderedCollection new.
	ScheduledWindow scheduledControllers size = 1 ifFalse: 
		[labels add: (#closeLauncherWindow &lt;&lt; #dialogs &gt;&gt; 'Close this Window').
		values add: #close].
	labels
		add: (#SaveThenExit &lt;&lt; #dialogs &gt;&gt; 'Save then Exit');
		add: (#ExitWithoutSaving &lt;&lt; #dialogs &gt;&gt; 'Exit without Saving');
		add: (#Cancel &lt;&lt; #dialogs &gt;&gt; 'Cancel').
	values addAll: #(#save #exit #cancel).
	result := Dialog choose: (#closeOrExit &lt;&lt; #dialogs &gt;&gt; 'Close Window or Exit?')
		fromVerticallyAlignedButtonsWithLabels: labels
		values: values
		default: #cancel
		for: builder window.
	result == #close ifTrue: [^true].
	result == #exit ifTrue: [ObjectMemory quit].
	result == #save ifTrue: [ObjectMemory saveDialogThenQuit: true].
	^false</body>

<body package="Tools-Misc" selector="enableConnections">enableConnections
	"Do anything you might want to do to enable or disable external components.
	 As a side-effect update the title.  This allows Parcels to change the Launcher's
	 title."

	self builder window label: self class title</body>

<body package="Tools-Misc" selector="inspectDependentsFieldsLabel">inspectDependentsFieldsLabel

	^(#DependentsFields1p &lt;&lt; #dialogs &gt;&gt; 'DependentsFields (&lt;1p&gt;)') 
		expandMacrosWith: DependentsFields size</body>

<body package="Tools-Misc" selector="inspectUndeclaredLabel">inspectUndeclaredLabel

	^(#Undeclared1p &lt;&lt; #dialogs &gt;&gt; 'Undeclared (&lt;1p&gt;)') 
		expandMacrosWith: Undeclared size</body>

<body package="Tools-Misc" selector="noticeOfWindowClose:">noticeOfWindowClose: aWindow

	toolDock release.
	^super noticeOfWindowClose: aWindow</body>

<body package="Tools-Misc" selector="openApplicationForClassNamed:">openApplicationForClassNamed: aSymbol

	self openApplicationForClassNamed: aSymbol withSelector: #open</body>

<body package="Tools-Misc" selector="openApplicationForClassNamed:withSelector:">openApplicationForClassNamed: aSymbol withSelector: aSelectorSymbol

	self applicationForClassNamed: aSymbol do: [:class| class perform: aSelectorSymbol]</body>

<body package="Tools-Misc" selector="rebuildMenu">rebuildMenu

	menuBar notNil
		ifTrue:
			[self
				rebuildMenu: menuBar
				with: self class fullMenuBar
				augmentTo: VisualLauncher]</body>

<body package="Tools-Misc" selector="reInstallInterface">reInstallInterface
	"Install the receiver's user interface again. Keep the same window. 
	This happens when changing projects, restarting, and look and feel 
	changes."

	| spec window wid cp wid2 |
	wid := builder componentAt: #textViewID.
	wid container removeComponent: wid.
	window := builder window.
	window component release.

	"event dispatcher has to be reset so that it doesn't hold on to
	old objects, such as keyboardProcessor, etc"
	window controller reInstallEventDispatcher.

	builder := UIBuilder new.
	builder setWindow: window.
	builder source: self.
	spec := self class interfaceSpecFor: #windowSpec.
	self preBuildWith: builder.
	builder add: spec.
	wid2 := builder componentAt: #textViewID.
	cp := wid2 container.
	cp removeComponent: wid2.
	wid2 release.
	wid2 widget release.    "It doesn't get sent to the edge decorators component unless it has created the edge widgets"
	cp addWrapper: wid.
	builder componentAt: #textViewID put: wid.
	wid widget controller keyboardProcessor: builder keyboardProcessor.
	self postBuildWith: builder.
	builder doFinalHookup.
	self postOpenWith: builder.
	(menuBar atNameKey: #toolbar) indication: builder window toolbarVisible.
	^builder</body>

<body package="Tools-Misc" selector="toolbarVisible">toolbarVisible

	^builder window toolbarVisible</body>

<body package="Tools-Misc" selector="updateStatusBar">updateStatusBar

	(self widgetAt: #statusBar)
		client: self statusBarSubapplication</body>

<body package="Tools-Misc" selector="windowEvent:from:">windowEvent: anEvent from: aWindow

	super windowEvent: anEvent from: aWindow.
	(anEvent key == #newGraphicsDevice or: [anEvent key == #reopen])
		ifTrue: [self reInstallInterface]</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>menus - pdp</category>

<body package="Debugger-Support" selector="browseAllProbedMethods">browseAllProbedMethods
	&lt;menuItem: #(#_BrowseProbes #pdp '&amp;Browse Probes')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes)
		position: 30.1&gt;
	PDPManager browseAllProbedMethods</body>

<body package="Debugger-Support" selector="clearTestExpressionLibrary">clearTestExpressionLibrary
	&lt;menuItem: #(#_ClearDot #pdp '&amp;Clear...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #testLibrary)
		position: 20.2&gt;
	ProbeTestExpressionEditor clearLibrary</body>

<body package="Debugger-Support" selector="clearWatchExpressionLibrary">clearWatchExpressionLibrary
	&lt;menuItem: #(#_ClearDot #pdp '&amp;Clear...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #watchLibrary)
		position: 20.2&gt;
	ProbeActionExpressionEditor clearLibrary</body>

<body package="Debugger-Support" selector="inspectDebugVars">inspectDebugVars
	&lt;menuItem: #(#_InspectDebugVariables #pdp '&amp;Inspect Debug Variables') 
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes)
		position: 30.2&gt;
	PDPManager debugVariables inspect</body>

<body package="Debugger-Support" selector="inspectTestExpressionLibrary">inspectTestExpressionLibrary
	&lt;menuItem: #(#_Inspect #pdp '&amp;Inspect')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #testLibrary)
		position: 20.1&gt;
	ProbeTestExpressionEditor inspectLibrary</body>

<body package="Debugger-Support" selector="inspectWatchExpressionLibrary">inspectWatchExpressionLibrary
	&lt;menuItem: #(#_Inspect #pdp '&amp;Inspect')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #watchLibrary)
		position: 20.1&gt;
	ProbeActionExpressionEditor inspectLibrary</body>

<body package="Debugger-Support" selector="loadTestExpressionLibrary">loadTestExpressionLibrary
	&lt;menuItem: #(#_LoadDot #pdp '&amp;Load...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #testLibrary)
		position: 10.1&gt;
	ProbeTestExpressionEditor readLibrary</body>

<body package="Debugger-Support" selector="loadWatchExpressionLibrary">loadWatchExpressionLibrary
	&lt;menuItem: #(#_LoadDot #pdp '&amp;Load...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #watchLibrary)
		position: 10.1&gt;
	ProbeActionExpressionEditor readLibrary</body>

<body package="Debugger-Support" selector="probeLibraryMenu">probeLibraryMenu
	&lt;submenu: #(#Probe_Library #pdp 'Probe &amp;Library')
		nameKey: #probeLibrary
		menu: #(#menuBar #probes)
		position: 50.1&gt;</body>

<body package="Debugger-Support" selector="probes">probes
	&lt;submenu: #(#_Debug #menus '&amp;Debug')
		nameKey: #probes
		menu: #(#menuBar)
		position: 10.031&gt;</body>

<body package="Debugger-Support" selector="purgeUnusedVars">purgeUnusedVars
	&lt;menuItem: #(#RemoveUnusedDebug_VariablesDots #pdp 'Remove Unused Debug &amp;Variables...') 
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes)
		position: 20.3&gt;
	(Dialog confirm: (#PurgeUnusedDebugVariables &lt;&lt; #pdp &gt;&gt; 'Purge unused debug variables?'))
			ifTrue: [PDPManager purgeUnusedDebugVariables]</body>

<body package="Debugger-Support" selector="purgeUnusedWatches">purgeUnusedWatches
	&lt;menuItem: #(#RemoveUnused_WatchWindowsDots #pdp 'Remove Unused &amp;Watch Windows...') 
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes)
		position: 20.2&gt;
	(Dialog confirm: (#PurgeUnusedWatches &lt;&lt; #pdp &gt;&gt; 'Purge unused watches?'))
			ifTrue: [PDPManager purgeUnusedWatchWindows]</body>

<body package="Debugger-Support" selector="readProbeLibrary">readProbeLibrary
	&lt;menuItem: #(#_LoadDot #pdp '&amp;Load...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar probes #probeLibrary)
		position: 10.1&gt;
	ProbedCompiledMethod readProbesFromFile</body>

<body package="Debugger-Support" selector="removeAllProbes">removeAllProbes
	&lt;menuItem: #(#_RemoveAllProbesDots #pdp '&amp;Remove All Probes...') 
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes)
		position: 20.1&gt;
	(Dialog confirm: (#RemoveAllProbesFromSystem &lt;&lt; #pdp &gt;&gt; 'Remove all probes from system?'))
		ifTrue: [ProbedCompiledMethod revertAllProbedMethodsInSystem]</body>

<body package="Debugger-Support" selector="saveProbeLibrary">saveProbeLibrary
	&lt;menuItem: #(#_SaveDot #pdp '&amp;Save...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #probeLibrary)
		position: 10.2&gt;
	ProbedCompiledMethod saveProbesToFile</body>

<body package="Debugger-Support" selector="saveTestExpressionLibrary">saveTestExpressionLibrary
	&lt;menuItem: #(#_SaveDot #pdp '&amp;Save...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #testLibrary)
		position: 10.2&gt;
	ProbeTestExpressionEditor saveLibrary</body>

<body package="Debugger-Support" selector="saveWatchExpressionLibrary">saveWatchExpressionLibrary
	&lt;menuItem: #(#_SaveDot #pdp '&amp;Save...')
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes #watchLibrary)
		position: 10.2&gt;
	ProbeActionExpressionEditor saveLibrary</body>

<body package="Debugger-Support" selector="testLibraryMenu">testLibraryMenu
	&lt;submenu: #(#_TestLibrary #pdp '&amp;Test Library')
		nameKey: #testLibrary
		menu: #(#menuBar #probes)
		position: 50.3&gt;</body>

<body package="Debugger-Support" selector="toggleDebugging">toggleDebugging
	&lt;menuItem: #toggleDebuggingLabel
		icon: nil
		nameKey: nil
		menu: #(#menuBar #probes)
		position: 10.1&gt;
	PDPManager toggleDebugging</body>

<body package="Debugger-Support" selector="toggleDebuggingLabel">toggleDebuggingLabel
	^PDPManager getEnableProbeDebuggingLabel</body>

<body package="Debugger-Support" selector="watchLibraryMenu">watchLibraryMenu
	&lt;submenu: #(#_WatchLibrary #pdp '&amp;Watch Library')
		nameKey: #watchLibrary
		menu: #(#menuBar #probes)
		position: 50.2&gt;</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>store</category>

<body package="Store-UI" selector="areAttached">areAttached

	^DbRegistry isConnected</body>

<body package="Store-UI" selector="notAttached">notAttached

	^self areAttached not</body>

<body package="Store-UI" selector="openLoadedPundleGraph">openLoadedPundleGraph

	"obsolete?"
	Store.PundleGraph openOnImage</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>store menus</category>

<body package="Store-UI" selector="administration">administration
	&lt;submenu: '&amp;Administration'
		nameKey: #administration
		menu: #(#menuBar #store)
		position: 90.01&gt;</body>

<body package="Store-UI" selector="browseClassDefinitions">browseClassDefinitions
	&lt;menuItem: 'Class named...'
		icon: nil
		nameKey: #browseClassDefinitions
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #browseDefinitions)
		position: 90.03&gt;

	| name list |
	name  := Dialog request: 'Class name'.
	name isEmpty ifTrue: [ ^self ].
	( name := Store.ClassRecord chooseNameMatching: name description: 'class' ) == nil
		ifTrue: [ ^self ].
	list := Store.ClassRecord allVersionsNamed: name.
	list isEmpty ifTrue: [ ^Dialog warn: name, ' has not been published.' ].
	TabApplicationSystemBrowser browseNamespaceOrClassList: list.</body>

<body package="Store-UI" selector="browseDefinitions">browseDefinitions
	&lt;submenu: 'Browse &amp;Definitions'
		nameKey: #browseDefinitions
		menu: #(#menuBar #store)
		position: 20.09&gt;</body>

<body package="Store-UI" selector="browseNameSpaceDefinitions">browseNameSpaceDefinitions
	&lt;menuItem: 'NameSpace named...'
		icon: nil
		nameKey: #browseNameSpaceDefinitions
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #browseDefinitions)
		position: 90.02&gt;

	| name list |
	name  := Dialog request: 'NameSpace name'.
	name isEmpty ifTrue: [ ^self ].
	( name := Store.NameSpaceRecord chooseNameMatching: name description: 'namespace' ) == nil
		ifTrue: [ ^self ].
	list := Store.NameSpaceRecord allVersionsNamed: name.
	list isEmpty ifTrue: [ ^Dialog warn: name, ' has not been published.' ].
	TabApplicationSystemBrowser browseNamespaceOrClassList: list.</body>

<body package="Store-UI" selector="browseSelector">browseSelector
	&lt;menuItem: 'Selector...'
		icon: nil
		nameKey: #browseSelector
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #browseDefinitions)
		position: 90.03&gt;

	| name list classes cls |
	name := ParagraphEditor currentSelection.
	name  := Dialog request: 'Selector'.
	name isEmpty ifTrue: [ ^self ].
	( name := Store.Method chooseNameMatching: name description: 'selector' ) == nil
		ifTrue: [ ^nil ].
	list := Store.Method allVersionsWithName: name.
	classes := list collect: [ :m | m classNameWithMeta asSymbol ].
	classes := classes asSet asSortedCollection asOrderedCollection.
	cls := classes size == 1
		ifTrue: [ classes first ]
		ifFalse: 
			[ Dialog 
				choose: ( '#&lt;1s&gt; in which class...'  expandMacrosWith: name )
				fromList: classes values: classes
				lines: 10 cancel: [ ^nil ]
				for: nil.
			].
	TabApplicationSystemBrowser 
		browseVersionsOfMethodNamed: name
		inClassNamed: cls asClassNameOnly
		meta: cls namesMetaClass</body>

<body package="Store-UI" selector="browseStatic">browseStatic
	&lt;menuItem: 'Shared Variable...'
		icon: nil
		nameKey: #browseStatic
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #browseDefinitions)
		position: 90.05&gt;

	| name list owners owner |
	name := ParagraphEditor currentSelection.
	name  := Dialog request: 'Shared Variable'.
	name isEmpty ifTrue: [ ^self ].
	( name := Store.DataElement chooseNameMatching: name description: 'shared variable' ) == nil
		ifTrue: [ ^nil ].
	list := Store.DataElement allVersionsWithName: name.
	owners := list collect: [ :m | m ownerName asSymbol ].
	owners := owners asSet asSortedCollection asOrderedCollection.
	owner := owners size == 1
		ifTrue: [ owners first ]
		ifFalse: 
			[ Dialog 
				choose: ( '#&lt;1s&gt; in which class...'  expandMacrosWith: name )
				fromList: owners values: owners
				lines: 10 cancel: [ ^nil ]
				for: nil.
			].
	TabApplicationSystemBrowser 
		browseVersionsOfStaticNamed: name
		inNamed: owner</body>

<body package="Store-UI" selector="browseUnpackaged">browseUnpackaged
	&lt;menuItem: 'Browse &amp;Unpackaged'
		icon: nil
		nameKey: nil
		menu: #(#menuBar #store)
		position: 20.07&gt;

	Store.PundleAccess moveUnpackagedToNullPackage.
	Refactory.Browser.RefactoringBrowser openOnEnvironment:  (Refactory.Browser.PundleEnvironment new pundles: (List with: Store.Registry nullPackage))</body>

<body package="Store-UI" selector="bundleOwnershipManagement">bundleOwnershipManagement

	&lt;menuItem: '&amp;Bundle Ownership'
		icon: nil
		nameKey: #bundleOwnershipManagement
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #administration)
		position: 90.05&gt;

	Store.DbRegistry doIfImageAdministrator:
		[ Store.BundlePrivilegeGraph open ] label: 'manage bundle ownership'.</body>

<body package="Store-UI" selector="checkConsistency">checkConsistency
	&lt;menuItem: 'Check Consistency'
		icon: nil
		nameKey: nil
		menu: #(#menuBar #store)
		position: 90.99&gt;

	| strm warning |
	strm := WriteStream on: String new.
	Cursor wait showWhile: [ Registry checkConsistencyOn: strm ].
	warning := strm contents.
	Dialog warn: 
		( warning size = 0
			ifTrue: [ 'Everything checks out fine' ]
			ifFalse: [ warning ] )</body>

<body package="Store-UI" selector="currentPackage">currentPackage
	&lt;menuItem: '&amp;Current Package...'
		icon: nil 
		nameKey: #currentPackage
		menu: #(#menuBar #store)
		position: 50.05&gt;

	| pkg |
	pkg := Registry currentPackage.
	pkg := PackageChooser
		chooseOrAdd: ( 'Current Package: ', pkg name )
		 withDefault: pkg 
		onCancelDo: [ ^self ].
	Registry currentPackage: pkg.</body>

<body package="Store-UI" selector="openGarbageCollectionDialog">openGarbageCollectionDialog
	&lt;menuItem: '&amp;Garbage Collection'
		icon: nil
		nameKey: nil
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #administration)
		position: 90.99&gt;

	Store.DbRegistry doIfImageAdministrator:
		[ Store.GarbageCollectSpecEditor open ] label: 'run garbage collection'.</body>

<body package="Store-UI" selector="openLoadedItems">openLoadedItems
	&lt;menuItem: '&amp;Loaded Items'
		icon: nil
		nameKey: nil
		menu: #(#menuBar #store)
		position: 20.01&gt;

	Store.PundlesTool openOnAllLoadedPundles</body>

<body package="Store-UI" selector="openMergeTool">openMergeTool
	&lt;menuItem: 'Merge &amp;Tool'
		icon: nil
		nameKey: nil
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store )
		position: 20.09&gt;

	Store.MergeTool open.</body>

<body package="Store-UI" selector="openPublishedItems">openPublishedItems
	&lt;menuItem: '&amp;Published Items'
		icon: nil
		nameKey: nil
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store)
		position: 20.02&gt;

	DbRegistry doIfOnlineImage: 
		[ Store.PublishedPundlesTool openOnAllPublishedPundles ]</body>

<body package="Store-UI" selector="openRecentPublishedItems">openRecentPublishedItems
	&lt;menuItem: '&amp;More Recently Published Items'
		icon: nil
		nameKey: nil
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store)
		position: 20.05&gt;

	| list list2 |
	DbRegistry doIfOnlineImage: 
		[ list := (Registry allPackagesWithNewerInDB collect: [ :pkg | pkg name ]) asSet.
		list2  := (Registry allBundlesWithNewerInDB collect: [ :bundle | bundle name ]) asSet.
		Store.PublishedPundlesTool openOnBundles: list2 packages: list title: 'More Recently Published Items'
		]</body>

<body package="Store-UI" selector="openUISettings">openUISettings
	&lt;menuItem: '&amp;Settings'
		icon: nil
		nameKey: nil
		menu: #(#menuBar #store)
		position: 50.01&gt;

	SettingsManager 
		openOrRaise: VisualWorksSettings 
		selectPage: #(#store)</body>

<body package="Store-UI" selector="packageOwnershipManagement">packageOwnershipManagement
	&lt;menuItem: 'Package &amp;Ownership'
		icon: nil
		nameKey: #packageOwnershipManagement
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #administration)
		position: 90.05&gt;

	Store.DbRegistry doIfImageAdministrator:
		[ Store.PrivilegeGraph open ] label: 'manage ownership'.</body>

<body package="Store-UI" selector="removeDatabaseLinks">removeDatabaseLinks
	&lt;menuItem: 'Remove Database Links...'
		icon: nil
		nameKey: nil
		menu: #(#menuBar #store)
		position: 90.10&gt;

	Store.Registry removeDatabaseLinks.</body>

<body package="Store-UI" selector="renameBundleInDatabase">renameBundleInDatabase
	&lt;menuItem: 'Rename Bundle in Database...'
		icon: nil
		nameKey: #renameBundle
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #administration)
		position: 90.10&gt;

	Store.DbRegistry doIfImageAdministrator:
		[ ( Dialog confirm: 'Renaming a bundle in the database will require all existing images to rename to match.&lt;ntttttttt&gt;Continue?' expandMacros )
			ifFalse: [ ^self ].
		Store.Bundle rename.
		] label: 'rename bundles'.</body>

<body package="Store-UI" selector="renamePackageInDatabase">renamePackageInDatabase
	&lt;menuItem: 'Rename Package in Database...'
		icon: nil
		nameKey: #renamePackage
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #administration)
		position: 90.11&gt;

	Store.DbRegistry doIfImageAdministrator:
		[ ( Dialog confirm: 'Renaming a package in the database will require all existing images to rename to match.&lt;ntttttttt&gt;Continue?' expandMacros )
			ifFalse: [ ^self ].
		Store.Package rename
		] label: 'rename packages'.</body>

<body package="Store-UI" selector="store">store
	&lt;submenu: 'St&amp;ore'
		nameKey: #store
		menu: #(#menuBar)
		position: 10.035&gt;</body>

<body package="Store-UI" selector="storeRepositoryLabelPart">storeRepositoryLabelPart

	| profileName |
	profileName := 'Repository'.
	DbRegistry connectedProfile ifNotNil: 
		[:profile | 
		profile name ifNotNil: 
			[:name | profileName := name]].
	^profileName</body>

<body package="Store-UI" selector="switchDatabases">switchDatabases
	&lt;menuItem: 'Switch Databases'
		icon: nil
		nameKey: nil
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store)
		position: 90.08&gt;

	Store.Registry switchDatabases.</body>

<body package="Store-UI" selector="toggleStoreConnectionItemLabel">toggleStoreConnectionItemLabel

	^DbRegistry isConnected
		ifTrue:  ['Disconnect from ', self storeRepositoryLabelPart]
		ifFalse: ['Connect to Repository...']</body>

<body package="Store-UI" selector="toggleStoreRepositoryConnection">toggleStoreRepositoryConnection
	&lt;menuItem: #toggleStoreConnectionItemLabel
		nameKey: nil
		menu: #(#menuBar #store)
		position: 10.5&gt;

	DbRegistry isConnected 
		ifTrue: [DbRegistry disconnect]
		ifFalse: [DbRegistry restoreConnection]</body>

<body package="Store-UI" selector="userGroupManagement">userGroupManagement
	&lt;menuItem: 'User/Group &amp;Management'
		icon: nil
		nameKey: #userGroupManagement
		enablement: #areAttached
		indication: nil
		menu: #(#menuBar #store #administration)
		position: 90.03&gt;

	Store.DbRegistry doIfImageAdministrator:
		[ Store.GroupGraph open ] label: 'manage user/groups'.</body>
</methods>

<methods>
<class-id>Tools.VisualLauncher</class-id> <category>actions Cormas</category>

<body package="cormas" selector="compileDictionaries"></body>

<body package="cormas" selector="createNameSpace:under:imports:category:"></body>

<body package="cormas" selector="exportCormas"></body>

<body package="cormas" selector="installCormas"></body>

<body package="cormas" selector="openCormasEn"></body>

<body package="cormas" selector="openCormasFr"></body>

<body package="cormas" selector="updateCormas"></body>

<body package="cormas" selector="version"></body>
</methods>

</st-source>
